<template>
    <div :style="{ 'margin-top': '50px' }">
        <table class="table  table-striped" v-if="liqBecasCabeceraStore.listadoCabeceraBecas.length > 0">
            <thead>
                <tr>
                    <th scope="col">Exp</th>
                    <th scope="col">Apellido y Nombre</th>
                    <th scope="col">Doc N°</th>
                    <th scope="col">Apellido y nombre Apoderado</th>
                    <th scope="col">Doc Apoderado</th>
                    <th scope="col">Líquido</th>
                    <th scope="col" :style="{ 'width': '230px' }">Período - N° Líq </th>
                    <th scope="col">Nro Pago</th>
                    <th scope="col">Fecha Líq</th>
                    <th scope="col">Solicitante</th>
                    <th scope="col">Bloque</th>
                    <th scope="col">Responsable</th>
                    <th scope="col">Suc Bapro</th>
                    <th scope="col">Detalle</th>
                    <th scope="col">Estado</th>
                    <th scope="col" v-if="props.tipoConsulta == 'Anular'">Anular/Desanular</th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="liq in liqBecasCabeceraStore.listadoCabeceraBecas" :key="liq.id_liq_cab">
                    <td v-text="liq.expediente"></td>
                    <td v-text="liq.apyn"></td>
                    <td v-text="liq.doc"></td>
                    <td v-text="liq.apyn_apoderado"></td>
                    <td v-text="liq.doc_apoderado"></td>
                    <td v-text="'$' + formatPrice(liq.Importe_total)"></td>
                    <td v-text="liq.f_periodo + '- N° ' + liq.nro_liq"></td>
                    <td v-text="liq.nro_opago"></td>
                    <td v-text="formatDate(liq.f_segu)"></td>
                    <td v-text="liq.apyn_sol"></td>
                    <td v-text="liq.d_dependen"></td>
                    <td v-text="liq.apyn_sol_resp"></td>
                    <td v-text="liq.baprosuc"></td>
                    <td>
                        <button class="btn btn-principal btn-sm pt-0 pb-0 px-1 mb-2 mt-0" alt="Mostrar"
                            title="mostrar datos" @click="mostrarDatos(liq)">
                            <i class="bi bi-search text-light"></i>
                        </button>
                    </td>
                    <td v-text="!liq.f_anulada ? liq.f_anulada : 'Anulada'"></td>
                    <td v-if="props.tipoConsulta == 'Anular' && liq.f_anulada !== null">
                        <button class="btn btn-principal btn-sm pt-0 pb-0 px-1 mb-2 mt-0" alt="Mostrar" title="DESANULAR"
                            @click="anularLiquidacion(liq, 0)">
                            DESANULAR
                        </button>
                    </td>
                    <td v-if="props.tipoConsulta == 'Anular' && liq.f_anulada == null">
                        <button class="btn btn-principal btn-sm pt-0 pb-0 px-1 mb-2 mt-0" alt="Mostrar" title="ANULAR"
                            @click="anularLiquidacion(liq, 1)">
                            ANULAR
                        </button>
                    </td>

                </tr>
            </tbody>
            <tfoot>
                <tr class="bg-princial text-light fs-5 text-uppercase text-center">
                    <th scope="col text-center" style="padding: 7px !important" v-text='"TOTALES:"'></th>
                    <th scope="col text-center" style="padding: 7px !important" colspan="4"></th>
                    <th scope="col text-center" style="padding: 7px !important" v-text='"IMPORTE:"'></th>
                    <th scope="col text-center" style="padding: 7px !important"
                        v-text="'$' + formatPrice(totales.totalImporte)"></th>
                    <th scope="col text-center" style="padding: 7px !important" colspan="6"></th>
                    <th scope="col text-center" style="padding: 7px !important" v-text='"CANT BECAS LIQ:"'></th>
                    <th scope="col text-center" style="padding: 7px !important" v-text="totales.cantBecasLiq">
                    </th>
                </tr>
            </tfoot>

        </table>
        <div v-else class="alert alert-secondary" role="alert">
            No hay elementos para mostrar
        </div>

        <Modal ref="modalDetalle" :title="'Detalle de liquidación'" size="xl" :vertical-centered="true">
            <DetalleLiquidacion :liq="data.liq" />
        </Modal>
    </div>
</template>
  
<script setup lang="ts">
import { ref, reactive, watch } from "vue";
import { Modal } from "@hcd-bsas/vue3-components";
import { DateTime } from "luxon";
import { loading, urlApi } from "@/shared.js";
import http from "@/http";


//store
import { useLiqBecasCabeceraStore } from "@/stores/Liquidaciones/cabeceraBecas";


//componentes
import DetalleLiquidacion from "@/components/Liquidaciones/DetalleLiquidacion.vue";
import type CabeceraBecas from "@/entities/Liquidaciones/CabeceraBecas";


import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions, SweetAlertResult } from "sweetalert2";

const props = defineProps({
    tipoConsulta: { type: String },
    paramBusqueda: { type: Object }

});

const liqBecasCabeceraStore = useLiqBecasCabeceraStore();


function formatDate(date: string | null) {

    if (date != null) {
        const fecha = date;
        const dt = DateTime.fromFormat(fecha, "yyyy-MM-dd HH:mm:ss.SSS");
        const fechaFormateada = dt.toFormat("dd/MM/yyyy HH:mm:ss");
        return fechaFormateada;
    }
}

function formatPrice(value: any) {
    let val = (value / 1).toFixed(2).replace('.', ',')
    return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".")
}

var data = reactive({
    liq: undefined as CabeceraBecas | undefined,

});

var totales = reactive({
    totalImporte: 0 as number,
    cantBecasLiq: 0 as number,

});

const modalDetalle = ref<typeof Modal>();
function mostrarDatos(liq: CabeceraBecas) {

    data.liq = liq;
    modalDetalle.value!.show();

}

function anularLiquidacion(liq: CabeceraBecas, tipo: Number) {

    let id_liq_cab = liq.id_liq_cab;
    let texto = '';
    let pregunta = '';
    if (tipo == 1) {
        pregunta = "¿Confirma la anulaci&oacute;n de la liquidaci&oacute;n ?";
        texto = "Se Anulo la liquidación.";
    } else {
        pregunta = "¿Confirma la Desanulaci&oacute;n de la liquidaci&oacute;n ?";
        texto = "Se Des-anulo la liquidación.";
    }

    const swal_error: SweetAlertOptions<any, any> = {
        icon: "error",
        title: "Error",
        html: "",
    }

    Swal.fire({
        icon: "question",
        title: "Confirmaci&oacute;n",
        html: pregunta,
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Confirmar",
        cancelButtonText: "Cancelar",
    }).then(async (result) => {
        if (result.isConfirmed) {
            loading.show();
            var rta = await http.post(urlApi + "anularLiquidacion", {
                id_liq_cab: id_liq_cab,
                anula: tipo
            }).then(async () => {

                //console.log(props.paramBusqueda); 
                //funciona pero es ineficiente por que busca nuevamente podria hacer un update de la lista 
                //revisar 
                await liqBecasCabeceraStore.getListadoConsultaLiquidacion(props.paramBusqueda);
                Swal.fire({
                    icon: "success",
                    text: texto,
                })

                loading.hide();
            }).catch(function (error: AxiosError<string, any>) {
                if (error.response) {
                    // Request made and server responded
                    swal_error.html =
                        error.message +
                        " (" +
                        error.code +
                        ")." +
                        "<br />" +
                        error.response.data.substring(
                            error.response.data.indexOf("<h2>") + 4,
                            error.response.data.indexOf("</h2>")
                        );
                    console.log("Error: request made and server responded");
                    console.log(swal_error.html);
                    console.log(error.response);
                } else if (error.request) {
                    // The request was made but no response was received
                    swal_error.html =
                        "Error desconocido. Por favor, avise al Administrador.";
                    console.log("Error: the request was made but no response was received");
                    console.log(error.request);
                } else {
                    // Something happened in setting up the request that triggered an Error
                    swal_error.html =
                        "Error desconocido. Por favor, avise al Administrador.";
                    console.log(
                        "Error: something happened in setting up the request that triggered an error"
                    );
                    console.log(error);
                }
                //  loading.hide();
                Swal.fire(swal_error);
            });
        }
    });
}

function desanularLiquidacion(liq: CabeceraBecas) {

    let id_liq_cab = liq.id_liq_cab;
    let anular = 0;
    console.log(id_liq_cab, 'desanular');
}

function calcularTotales() {
    var liqCab = liqBecasCabeceraStore.listadoCabeceraBecas;
    liqCab.forEach(element => {
        totales.totalImporte += Math.abs(element.Importe_total);
        totales.cantBecasLiq += 1;
    });
}

watch(() => liqBecasCabeceraStore.listadoCabeceraBecas, async (newValue: any, oldValue: any) => {
    if (newValue.length > 0) {
        totales.totalImporte = 0;
        totales.cantBecasLiq = 0;
        calcularTotales();
    }
});

</script>
  